// -------------------- Code

#include "MainWnd.h"

CMainWnd * g_pMainWnd = NULL;

CMainWnd::CMainWnd()
{
    m_bPaused = false;
    g_pMainWnd = this;
    m_bReallyClose = false;
}

CMainWnd::~CMainWnd() 
{
    //nothing
}

HWND CMainWnd::Create(HINSTANCE hInstance)
{
    HWND        hWnd;
    WNDCLASSEX  wndclass;

    m_hInstance = hInstance;

    //set parameters for window
    wndclass.cbSize = sizeof(wndclass);
    wndclass.style = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc = MainWndProc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = 0;
    wndclass.hInstance = hInstance;
    wndclass.hIcon = LoadIcon(hInstance, 
                     MAKEINTRESOURCE(IDI_MAINICON));
    wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
    wndclass.lpszMenuName = NULL; 
                            /* MAKEINTRESOURCE(IDR_MAINMENU); */
    wndclass.lpszClassName = MAINWND_CLASS;
    wndclass.hIconSm = (HICON) LoadImage(m_hInstance, 
                           MAKEINTRESOURCE(IDI_MAINICON), 
                           IMAGE_ICON, 16, 16, 0);

    //register window
    RegisterClassEx ( &wndclass );

    //create main window
    hWnd = CreateWindowEx (NULL, MAINWND_CLASS, MAINWND_TITLE, 
        WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_SIZEBOX, 
        CW_USEDEFAULT, CW_USEDEFAULT, 400, 370, 
        NULL, NULL, hInstance, NULL);

    bool bStartItUp = true;

    if (!ProcessCommandLine())
    {
        PostMessage(m_hWnd, WM_REALLY_CLOSE, 0, 0);
        bStartItUp = false;
    }

    if (bStartItUp)
    {
        if (g_pSettings->nService == 1)
        {
            char szPath[MAX_PATH];
            char szPathQuote[MAX_PATH+2];
            GetModuleFileName(NULL, szPath, MAX_PATH);
            szPathQuote[0] = '"';
            szPathQuote[1] = 0;
            strcat(szPathQuote, szPath);
            strcat(szPathQuote, "\"");
            SC_HANDLE hSC = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
            CreateService(hSC, SERVICE_NAME, SERVICE_NAME, SERVICE_ALL_ACCESS, SERVICE_WIN32_OWN_PROCESS, 
                SERVICE_DEMAND_START, SERVICE_ERROR_IGNORE, szPathQuote, NULL, NULL, NULL, NULL, NULL);
            CloseServiceHandle(hSC);

            MessageBox(m_hWnd, _T("Service registered"), _T("TiVo Crack"), MB_TOPMOST);

            PostMessage(m_hWnd, WM_REALLY_CLOSE, 0, 0);
            bStartItUp = false;
        }
        else if (g_pSettings->nService == 2)
        {
            SC_HANDLE hSC = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
            SC_HANDLE hTiVo = OpenService(hSC, SERVICE_NAME, SERVICE_ALL_ACCESS);
            DeleteService(hTiVo);
            CloseServiceHandle(hSC);

            MessageBox(m_hWnd, _T("Service de-registered"), _T("TiVo Crack"), MB_TOPMOST);

            PostMessage(m_hWnd, WM_REALLY_CLOSE, 0, 0);
            bStartItUp = false;
        }
    }

    if (bStartItUp)
    {
        if (g_bIsService)
        {
            g_bShutdownWindow = true;
            g_pSettings->nStart = 2;
        }

        if (g_pSettings->nStart != 2)
        {
            Shell_NotifyIcon(NIM_ADD, &m_nid);
        }
        if (g_pSettings->nStart == 0)
        {
            ShowWindow (m_hWnd, SW_NORMAL);
            UpdateWindow (m_hWnd);
        }

        DWORD dwThread;
        HANDLE hThread = CreateThread(NULL, 0, WatcherThread, 
            0, NULL, &dwThread);
        if (g_pSettings->bLowPri)
        {
            SetThreadPriority(hThread, 
                THREAD_PRIORITY_BELOW_NORMAL);
        }
    
    }

    if (g_pSettings->bLowPri)
    {
        SetPriorityClass(GetCurrentProcess(), 
            IDLE_PRIORITY_CLASS);
    }

    return hWnd;
}

LRESULT CMainWnd::OnSize(DWORD dwFlag, WORD wWidth, WORD wHeight)
{

    if (dwFlag == SIZE_MINIMIZED)
    {
        ShowWindow(m_hWnd, SW_HIDE);
        return 0;
    }

    MoveWindow(m_hWndList, 0, 0, wWidth, wHeight, TRUE);

    return 0;
}

LRESULT CMainWnd::OnSystray(DWORD dwMessage)
{

    switch(dwMessage)
    {
    case WM_LBUTTONDBLCLK:
        ShowWindow(m_hWnd, SW_RESTORE);
        SetForegroundWindow(m_hWnd);
        break;
    case WM_RBUTTONUP:
        SetForegroundWindow(m_hWnd);
        OnSystrayContext();
    }

    return 0;

}

void CMainWnd::OnSystrayContext()
{

    HMENU hMenu = CreatePopupMenu();
    AppendMenu(hMenu, MF_STRING, IDM_OPEN, "&Open");
    if (m_bPaused)
    {
        AppendMenu(hMenu, MF_STRING, IDM_PAUSE, "Resum&e");
    }
    else
    {
        AppendMenu(hMenu, MF_STRING, IDM_PAUSE, "Paus&e");
    }
    AppendMenu(hMenu, MF_STRING, IDM_EXIT, "E&xit");
    AppendMenu(hMenu, MF_SEPARATOR, NULL, NULL);
    AppendMenu(hMenu, MF_STRING, IDM_HOMEPAGE, "Open &website...");

    SetMenuDefaultItem(hMenu, IDM_OPEN, FALSE);

    POINT pt;
    GetCursorPos(&pt);

    switch (TrackPopupMenu(hMenu, TPM_RIGHTALIGN | TPM_BOTTOMALIGN | 
        TPM_NONOTIFY | TPM_RETURNCMD | TPM_RIGHTBUTTON, 
        pt.x, pt.y, 0, m_hWnd, NULL))
    {
    case IDM_OPEN:
        ShowWindow(m_hWnd, SW_RESTORE);
        SetForegroundWindow(m_hWnd);
        break;

    case IDM_PAUSE:
        PauseApp();
        break;

    case IDM_EXIT:
        PostMessage(m_hWnd, WM_CLOSE, 0, 0);
        break;

    case IDM_HOMEPAGE:
        {
	    SHELLEXECUTEINFO sei = {0};
	    
	    sei.cbSize = sizeof(sei);
	    sei.lpVerb = "Open";
	    sei.lpFile = "http://edo.lcs.mit.edu/dclient/";
	    sei.nShow = SW_SHOW;
	    sei.hInstApp = m_hInstance;

	    ShellExecuteEx(&sei);
        }
        break;

    }

    DestroyMenu(hMenu);


}

LRESULT CMainWnd::OnError()
{
    EnterCriticalSection(&g_crit);
    m_nid.hIcon = m_hIconPaused;
    LeaveCriticalSection(&g_crit);
    if (g_pSettings->nStart != 2)
    {
        Shell_NotifyIcon(NIM_MODIFY, &m_nid);
    }
    return 0;
}

void CMainWnd::PauseApp()
{
    CThread * pCur;

    EnterCriticalSection(&g_crit);
    m_bPaused = !m_bPaused;
    if (m_bPaused)
    {
        WriteInfo("Paused");
        m_nid.hIcon = m_hIconPaused;
    }
    else
    {
        WriteInfo("Resumed");
        m_nid.hIcon = m_hIconNormal;
    }
    for (pCur = g_pThread; pCur; pCur = pCur->pNext)
    {
        if (m_bPaused)
        {
            SuspendThread(pCur->hThread);
        }
        else
        {
            ResumeThread(pCur->hThread);
        }
    }
    LeaveCriticalSection(&g_crit);
    if (g_pSettings->nStart != 2)
    {
        Shell_NotifyIcon(NIM_MODIFY, &m_nid);
    }
}

LRESULT CMainWnd::OnReallyClose()
{
    m_bReallyClose = true;
    OnClose();
    m_bReallyClose = false;

    return 0;
}

// Main window Prodecure
LRESULT CALLBACK CMainWnd::MainWndProc ( HWND hWnd, UINT iMsg, 
   WPARAM wParam, LPARAM lParam)
{

    static UINT uTaskMsg = RegisterWindowMessage("TaskbarCreated");

    switch (iMsg)
    {
    case WM_REALLY_CLOSE:
        return g_pMainWnd->OnReallyClose();

    case WM_USER_PAUSE :
        if (!g_pMainWnd->m_bPaused)
        {
            g_pMainWnd->PauseApp();
        }
        break;

    case WM_USER_CONT:
        if (g_pMainWnd->m_bPaused)
        {
            g_pMainWnd->PauseApp();
        }
        break;

    case WM_USER_SYSTRAY :
        return g_pMainWnd->OnSystray(lParam);
        
    case WM_SIZE :
        return g_pMainWnd->OnSize(wParam, LOWORD(lParam), HIWORD(lParam));

    case WM_CREATE :
        g_pMainWnd->m_hWnd = hWnd;
        return g_pMainWnd->OnCreate();

    case WM_CLOSE :
        return g_pMainWnd->OnClose();

    case WM_DESTROY :
        return g_pMainWnd->OnDestroy();

    case WM_USER_ERROR:
        return g_pMainWnd->OnError();

    case WM_USER_LOG :
        return g_pMainWnd->OnLog((char *) lParam);

    default:
        if (iMsg == uTaskMsg)
        {
            if (g_pSettings->nStart != 2)
            {
                Shell_NotifyIcon(NIM_ADD, &g_pMainWnd->m_nid);
            }
            return 0;
        }
        break;

    }

    return DefWindowProc (hWnd, iMsg, wParam, lParam);
}

LRESULT CMainWnd::OnClose()
{

    EnterCriticalSection(&g_crit);
    if (g_pSettings->nStart != 2 && !g_bIsService && !m_bReallyClose)
    {
        int nRet;
        if (g_pSettings->bLocalMode)
        {
            nRet = MessageBox(m_hWnd, 
                "Are you sure you want to exit TiVoCrack and abort the current work?", 
                "Close TiVoCrack?", 
                MB_YESNO | MB_ICONQUESTION);
            if (nRet == IDNO)
            {
                nRet = IDCANCEL;
            }
        }
        else
        {
            nRet = MessageBox(
                m_hWnd, 
                "Are you sure you want to exit TiVoCrack and abort the current work?\n\n"
                "Yes = Close now, abandoning the current unit\n"
                "No = Close after the current work unit is complete\n"
                "Cancel = Forget you asked", 
                "Close TiVoCrack?", 
                MB_YESNOCANCEL | MB_ICONQUESTION);
        }

        switch (nRet)
        {
        case IDYES: // I'm sure
            // do nothing
            break;
        case IDNO: // After the work unit
            g_bFinishCurrent = true;
            g_bShutdownWindow = true;
            WriteInfo("Will abort after the current work unit");
            LeaveCriticalSection(&g_crit);
            return 0;

            break;
        case IDCANCEL: // Cancel
            LeaveCriticalSection(&g_crit);
            return 0;
            break;
        }

    }
    LeaveCriticalSection(&g_crit);

    if (m_bPaused)
    {
        PauseApp();
    }

    EnterCriticalSection(&g_crit);
    if (g_nWorkerRunning == 0)
    {
        if (g_pSettings->nStart != 2)
        {
            Shell_NotifyIcon(NIM_DELETE, &m_nid);
        }
        DestroyWindow(m_hWnd);
    }
    else
    {
        SetEvent(g_eventStop);
        g_bWorkerRunning = false;
        WriteInfo("Stopping");
        g_bNoMore = true;
        g_bShutdownWindow = true;
    }
    LeaveCriticalSection(&g_crit);

    return 0;

}

LRESULT CMainWnd::OnDestroy() 
{

    PostQuitMessage(0);

    return 0;
}

LRESULT CMainWnd::OnCreate() 
{
	m_hWndList = CreateWindowEx(NULL, _T("LISTBOX"), _T(""), 
		WS_CHILD | WS_VISIBLE | LBS_NOINTEGRALHEIGHT | WS_VSCROLL, 
		0, 0, 0, 0,
		m_hWnd, NULL, m_hInstance, 0);

    m_hIconNormal = LoadIcon(m_hInstance, MAKEINTRESOURCE(IDI_MAINICON));
    m_hIconPaused = LoadIcon(m_hInstance, MAKEINTRESOURCE(IDI_PAUSEICON));

    m_nid.cbSize = sizeof m_nid;
    m_nid.hIcon = m_hIconNormal;
    m_nid.hWnd = m_hWnd;
    strcpy(m_nid.szTip, "TiVo Crack");
    m_nid.uCallbackMessage = WM_USER_SYSTRAY;
    m_nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
    m_nid.uID = 1;

    HFONT hFontDef = (HFONT) GetStockObject(DEFAULT_GUI_FONT);

	SendMessage(m_hWndList, WM_SETFONT, (WPARAM) hFontDef, 0);
    
    return 0;
}

void CMainWnd::Log(char * szLog)
{

    if (strlen(szLog) < 64)
    {
        strcpy(m_nid.szTip, szLog);
    }
    else
    {
        memset(m_nid.szTip,0,64);
        memcpy(m_nid.szTip, szLog, 63);
    }
    if (g_pSettings->nStart != 2)
    {
        Shell_NotifyIcon(NIM_MODIFY, &m_nid);
    }

    SendMessage(m_hWndList, LB_INSERTSTRING, (WPARAM) -1, (LPARAM) szLog);

    while (SendMessage(m_hWndList, LB_GETCOUNT, 0, 0) > 1000)
    {
        SendMessage(m_hWndList, LB_DELETESTRING, 0, 0);
    }

    SendMessage(m_hWndList, LB_SETCURSEL, 
        SendMessage(m_hWndList, LB_GETCOUNT, 0, 0) - 1, 0);


}

LRESULT CMainWnd::OnLog(char * szLog)
{

    Log(szLog);
    xfree(szLog);

    return 0;
}

HWND CMainWnd::GethWnd()
{
    return m_hWnd;
}
