class CSettings;
class CWorkUnit;
class CThread;

#ifndef SETTINGOBJ_H__INCLUDED__
#define SETTINGOBJ_H__INCLUDED__

#include "main.h"

// Rather simple object to store all the settings
class CSettings
{
public:
            CSettings();
            ~CSettings();

    void    ResetAll();
    void    FreeAll();

    void    SetFromWorkUnit(CWorkUnit * pWorkUnit);

    char*   szUser;  // The user name
    char*   szPattern; // The pattern
    bool    bShutDown; // Told to shutdown by the server?
    char*   szGetURL; // The URL of the server
    char*   szHash; // The text of the hash to work against
    char*   szAlphabet; // The alphabet to use
    int     cAlphabet; // Count of alphabet
    bool    bLocalMode; // Work in local mode
    bool    bSilent; // Less output to the console
    bool    bLowPri; // Lower priority threads
    int     nSleepMins; // Amount of time to sleep between outputs
    int     nRetries; // Number of retries before failure
    int     nOutMode; // Output mode (see help)
    int     nStart; // Startup mode (minimzed, etc)
    DWORD   dwThreads; // How many threads should we launch?
    int     nService; // Service settings
    int     nDownloadAtOnce; //How many work units to grab at one go?
    bool    bReportKKeys; //Report the number of k/keys a sec?
private:

    void    SetAll();
};

// One work unit:  (Some overlap with settings)
class CWorkUnit
{
public:
            CWorkUnit();
            ~CWorkUnit();

    void    ResetAll();
    void    FreeAll();

    char*   szPattern; // The pattern
    char    szDecodedMatch[MAX_STRING]; // The match
    char*   szWuid; // The work unit ID
    char*   szResultURL; // Where the result goes to
    char*   szNonce; // Wuid verification
    char*   szSeed; // The seed for the pattern
    char*   szHash; // The text of the hash to work against
    char*   szAlphabet; // The alphabet to use
    int     cAlphabet; // Count of alphabet
    DWORD   dwProof; // The proof (used to verify work units)
private:

    void    SetAll();
};

class CThread
{
public:
    HANDLE  hThread;
    DWORD   dwID;
    CThread * pNext;
};


#endif // SETTINGOBJ_H__INCLUDED__
