#include "TivoCrack.h"

// All the global vars
char    g_szCurrentWord[MAX_LETTERS+1] = {0};
int     g_nCurrentWord[MAX_LETTERS+1] = {0};
int     g_cCurrentWord = 0;
bool    g_bWorkerRunning = true;
int     g_nWorkerRunning = 0;
char    g_szMessage[MAX_STRING] = "";
HANDLE  g_eventStop;
CRITICAL_SECTION g_crit;
DWORD   g_dwKey1[5];
DWORD   g_dwKey2[5];
bool    g_bNoMore = false;
bool    g_bNoMoreWords = false;
bool    g_bShutdownWindow = false;
bool    g_bFinishCurrent = false;
DWORD   g_dwTickStart;
DWORD   g_dwTickEnd;
double  g_nKeysCalced;
CThread *    g_pThread = NULL;

CSettings *  g_pSettings = NULL;
CWorkUnit *  g_pWorkUnit = NULL;
CWorkUnit ** g_pWorkUnits = NULL;
int          g_nCurWorkUnit = 0;

#ifdef TIME_CALCULATION
#define TIME_COUNT 5
DWORD   g_dwFindWordStart[TIME_COUNT] = {0};
DWORD   g_dwFindWordEnd[TIME_COUNT] = {0};
DWORD   g_dwBruteStart[TIME_COUNT] = {0};
DWORD   g_dwBruteEnd[TIME_COUNT] = {0};
int     g_nCurTime;
DWORD   g_dwBrute = 0;
DWORD   g_dwFind = 0;
#endif

void TiVoCrack_Init()
{
    g_pSettings = new CSettings();
    xtrack(g_pSettings);
    g_pWorkUnit = new CWorkUnit();
    xtrack(g_pWorkUnit);

    g_pWorkUnits = (CWorkUnit**) xmalloc((sizeof(CWorkUnit*)) * 1);
    g_pWorkUnits[0] = g_pWorkUnit;
}

void TiVoCrack_Uninit()
{
    xuntrack(g_pSettings);
    delete g_pSettings;
    xuntrack(g_pWorkUnit);
    delete g_pWorkUnit;
}

// Simple wrapper function that can call either Get or Put and retry 
// on failure
bool SafeNextWorkLoad(WorkLoadFunc pFunc)
{
    if (g_bNoMore)
    {
        return false;
    }

    if (!pFunc())
    {
        if (g_pSettings->nRetries == 0)
        {
            return false;
        }

        WriteInfo("Call failed, trying again");
        int nRetry = 0;
        char szMsg[MAX_STRING];
        bool bPass = false;
        int nMax = g_pSettings->nRetries;
        if (nMax == -1)
        {
            nMax = 10;
        }
        
        for (nRetry = 0; nRetry < nMax && !bPass; nRetry ++)
        {
            if (g_bNoMore)
            {
                return false;
            }
            WriteInfo("Sleeping for a minute");
            WaitForSingleObject(g_eventStop, 60000);
            if (g_bNoMore)
            {
                return false;
            }
            sprintf(szMsg, "Try number %d", nRetry + 2);
            WriteInfo(szMsg);
            bPass = pFunc();
            if (g_pSettings->nRetries == -1)
            {
                nMax = nRetry + 10;
            }
        }
        if (g_pSettings->bShutDown)
        {
            return false;
        }
        if (bPass)
        {
            WriteInfo("Call passed after retry");
            return true;
        }
        else
        {
            WriteInfo("Failed too many times, giving up");
            return false;
        }
    }
    return true;
}

// Handle a Ctrl-C
BOOL WINAPI CtrlHandler(DWORD)
{
    EnterCriticalSection(&g_crit);
    g_bWorkerRunning = false;
    WriteInfo("Stopping");
    g_bNoMore = true;
    LeaveCriticalSection(&g_crit);
    while (true)
    {
        Sleep(1000);
        EnterCriticalSection(&g_crit);
        if (g_nWorkerRunning == 0)
        {
            WriteInfo("Stopped");
            LeaveCriticalSection(&g_crit);
            SetEvent(g_eventStop);
            return(TRUE);
        }
        LeaveCriticalSection(&g_crit);
    }
}

// Just put szAdd to the end of szURL, encoding everything
//  that needs to be encoded
void SafeAdd(char* szURL, char * szBefore, char* szAdd)
{

    strcat(szURL, szBefore);

    int i;
    int nMax = strlen(szAdd);
    char szTemp[10];
    for (i = 0; i < nMax; i ++)
    {
        if ((szAdd[i] >= '0' && szAdd[i] <= '9') ||
            (szAdd[i] >= 'a' && szAdd[i] <= 'z') ||
            (szAdd[i] >= 'A' && szAdd[i] <= 'Z'))
        {
            szTemp[0] = szAdd[i];
            szTemp[1] = 0;
        }
        else
        {
            sprintf(szTemp, "%02X", szAdd[i]);
            strcat(szURL, "%");
        }
        strcat(szURL, szTemp);
    }
}

// Get the next workload from the server
bool GetNextWorkLoad()
{
#ifdef FAKE_GET_PUT
    WriteInfo("Get called!");
    g_pWorkUnit->dwProof = 0;

    xfree(g_pWorkUnit->szAlphabet);
    xfree(g_pWorkUnit->szHash);
    xfree(g_pWorkUnit->szNonce);
    xfree(g_pWorkUnit->szPattern);
    xfree(g_pWorkUnit->szResultURL);
    xfree(g_pWorkUnit->szSeed);
    xfree(g_pWorkUnit->szWuid);

    g_pWorkUnit->szAlphabet = xstrdup("ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789");
    g_pWorkUnit->cAlphabet = strlen(g_pWorkUnit->szAlphabet);
    g_pWorkUnit->szDecodedMatch[0] = 0;
    g_pWorkUnit->szHash = xstrdup("5CA5D9DBE5338BAB8690C79C9A9310BCD3A8F23B");
    g_pWorkUnit->szNonce = xstrdup("123");
    g_pWorkUnit->szPattern = xstrdup("??????");
    g_pWorkUnit->szResultURL = xstrdup("http://nowhere/");
    g_pWorkUnit->szSeed = xstrdup("AB");
    g_pWorkUnit->szWuid = xstrdup("321");

    return true;
#else
    g_pWorkUnit->dwProof = 0;

    if (g_bNoMore)
    {
        return false;
    }

    if (g_pSettings->nDownloadAtOnce > 1)
    {
        char szInfo[64];
        sprintf(szInfo, "Getting the next work load (%d/%d)",
            g_nCurWorkUnit + 1, g_pSettings->nDownloadAtOnce);
        WriteInfo(szInfo);
    }
    else
    {
        WriteInfo("Getting the next work load");
    }

    char szURL[MAX_STRING];

    strcpy(szURL, g_pSettings->szGetURL);

    SafeAdd(szURL, "?USERID=", g_pSettings->szUser);
    SafeAdd(szURL, "&CVER=", CLIENT_NAME "_" VERSION_TEXT);
    
    // Use the Windows Internet APIs to make our lives much easier
    HANDLE hInternet;
    HANDLE hFile;
    BYTE lpData[1024] = {0};
    BYTE * lpDataTemp = lpData;
    DWORD dwCount = 1024;
    DWORD dwReadTotal = 0;
    DWORD dwRead;

    hInternet = InternetOpen("TiVoCrack", 
        INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, NULL);

    if (hInternet == NULL)
    {
        WriteInfo("Unable to open internet connection!");
        return false;
    }
    hFile = InternetOpenUrl(
        hInternet, 
        szURL,
        NULL, NULL, 
        INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_NO_UI | 
        INTERNET_FLAG_PRAGMA_NOCACHE | INTERNET_FLAG_RELOAD |
        INTERNET_FLAG_KEEP_CONNECTION,
        NULL);
    if (hFile == NULL)
    {
        WriteInfo("Unable to open URL!");
        return false;
    }

    do 
    {
        if (InternetReadFile(hFile, lpDataTemp, dwCount, 
            &dwRead) == FALSE)
        {
            WriteInfo("Unable to read data from URL!");
            return false;
        }
        else
        {
            dwReadTotal += dwRead;
            lpDataTemp += dwRead;
            dwCount -= dwRead;
        }
    } while (dwRead);

    InternetCloseHandle(hFile);
    InternetCloseHandle(hInternet);

    char * szNext;
    char * szCur;
    char * szEqual;
    char szMessage[MAX_STRING];

    bool bHasWuid = false;
    bool bHasResultURL = false;
    bool bHasNonce = false;
    bool bHasRun = false;
    bool bHasCText = false;
    bool bHasAlphabet = false;
    bool bHasMessage = false;
    bool bHasPattern = false;
    bool bHasSeed = false;
    bool bHasStatus = false;

    bool bGoodUnit = true;

    szCur = (char*) lpData;
    szNext = (char*) lpData;

    while (*szNext)
    {

        if (*szNext == '\r')
        {
            *szNext = 0;
        }
        else if (*szNext == '\n')
        {
            *szNext = 0;
            if (strlen(szCur) > 0)
            {
                szEqual = szCur;
                while (*szEqual && *szEqual != '=')
                {
                    szEqual++;
                }
                if (*szEqual != '=')
                {
                    WriteInfo("Error processing line from server");
                    bGoodUnit = false;
                }
                else
                {
                    *szEqual = 0;
                    szEqual ++;
                    if (strcmp(szCur, "WUID") == 0)
                    {
                        if (bHasWuid)
                        {
                            WriteInfo("Warning: Two WUIDs received "
                                "from server");
                        }
                        bHasWuid = true;
                        xfree(g_pWorkUnit->szWuid);
                        g_pWorkUnit->szWuid = xstrdup(szEqual);
                    }
                    else if (strcmp(szCur, "RESULTURL") == 0)
                    {
                        if (bHasResultURL)
                        {
                            WriteInfo("Warning: Two RESULTURLs "
                                "received from server");
                        }
                        bHasResultURL = true;
                        xfree(g_pWorkUnit->szResultURL);
                        g_pWorkUnit->szResultURL = xstrdup(szEqual);
                    }
                    else if (strcmp(szCur, "NONCE") == 0)
                    {
                        if (bHasNonce)
                        {
                            WriteInfo("Warning: Two NONCEs received "
                                "from server");
                        }
                        bHasNonce = true;
                        xfree(g_pWorkUnit->szNonce);
                        g_pWorkUnit->szNonce = xstrdup(szEqual);
                    }
                    else if (strcmp(szCur, "RUN") == 0)
                    {
                        if (bHasRun)
                        {
                            WriteInfo("Warning: Two RUNs received "
                                "from server");
                        }
                        bHasRun = true;
                        // Just verify the run is what we want:
                        if (strcmp(szEqual, "TC2") != 0)
                        {
                            sprintf(szMessage, "Error: Unknown run: "
                                "[%s]", szEqual);
                            WriteInfo(szMessage);
                            bGoodUnit = false;
                        }
                    }
                    else if (strcmp(szCur, "CTEXT") == 0)
                    {
                        if (bHasCText)
                        {
                            WriteInfo("Warning: Two CTEXTs received "
                                "from server");
                        }
                        bHasCText = true;
                        xfree(g_pWorkUnit->szHash);
                        g_pWorkUnit->szHash = xstrdup(szEqual);
                    }
                    else if (strcmp(szCur, "ALPHABET") == 0)
                    {
                        if (bHasAlphabet)
                        {
                            WriteInfo("Warning: Two ALPHABETs "
                                "received from server");
                        }
                        bHasAlphabet = true;
                        xfree(g_pWorkUnit->szAlphabet);
                        g_pWorkUnit->szAlphabet = xstrdup(szEqual);
                        g_pWorkUnit->cAlphabet = strlen(g_pWorkUnit->szAlphabet);
                    }
                    else if (strcmp(szCur, "PATTERN") == 0)
                    {
                        if (bHasPattern)
                        {
                            WriteInfo("Warning: Two PATTERNs "
                                "received from server");
                        }
                        bHasPattern = true;
                        xfree(g_pWorkUnit->szPattern);
                        g_pWorkUnit->szPattern = xstrdup(szEqual);
                    }
                    else if (strcmp(szCur, "SEED") == 0)
                    {
                        if (bHasSeed)
                        {
                            WriteInfo("Warning: Two SEEDs received "
                                "from server");
                        }
                        bHasSeed = true;
                        xfree(g_pWorkUnit->szSeed);
                        g_pWorkUnit->szSeed = xstrdup(szEqual);
                    }
                    else if (strcmp(szCur, "STATUS") == 0)
                    {
                        if (bHasStatus)
                        {
                            WriteInfo("Warning: Two STATUSes "
                                "received from server");
                        }
                        bHasStatus = true;
                        // Just verify the run is what we want:
                        if (strcmp(szEqual, "OKAY") == 0)
                        {
                            // Good result, so do nothing
                        }
                        else if (strcmp(szEqual, "NOWORK") == 0)
                        {
                            WriteInfo("Error: No more work to do");
                            g_pSettings->bShutDown = true;
                            bGoodUnit = false;
                        }
                        else if (strcmp(szEqual, "FAIL") == 0)
                        {
                            WriteInfo("Error: Failure code from "
                                "server");
                            bGoodUnit = false;
                        }
                        else if (strcmp(szEqual, "SHUTDOWN") == 0)
                        {
                            WriteInfo("Error: Server told me to "
                                "shut down");
                            bGoodUnit = false;
                            g_pSettings->bShutDown = true;
                        }
                        else
                        {
                            sprintf(szMessage, "Error: Bad status: "
                                "[%s]", szEqual);
                            WriteInfo(szMessage);
                            bGoodUnit = false;
                        }
                    }
                    else if (strcmp(szCur, "MESSAGE") == 0)
                    {
                        if (bHasMessage)
                        {
                            WriteInfo("Warning: Two MESSAGEs "
                                "received from server");
                        }
                        bHasMessage = true;
                        sprintf(szMessage, "Server message: %s", 
                            szEqual);
                        WriteInfo(szMessage);
                    }
                }
            }

            szCur = szNext + 1;
        }
        szNext ++;
    }

    if (!bHasWuid)
    {
        WriteInfo("Didn't receive WUID from server!");
        bGoodUnit = false;
    }
    if (!bHasResultURL)
    {
        WriteInfo("Didn't receive RESULTURL from server!");
        bGoodUnit = false;
    }
    if (!bHasNonce)
    {
        WriteInfo("Didn't receive NONCE from server!");
        bGoodUnit = false;
    }
    if (!bHasRun)
    {
        WriteInfo("Didn't receive RUN from server!");
        bGoodUnit = false;
    }
    if (!bHasCText)
    {
        WriteInfo("Didn't receive CTEXT from server!");
        bGoodUnit = false;
    }
    if (!bHasAlphabet)
    {
        WriteInfo("Didn't receive ALPHABET from server!");
        bGoodUnit = false;
    }
    if (!bHasPattern)
    {
        WriteInfo("Didn't receive PATTERN from server!");
        bGoodUnit = false;
    }
    if (!bHasSeed)
    {
        WriteInfo("Didn't receive SEED from server!");
        bGoodUnit = false;
    }
    if (!bHasStatus)
    {
        WriteInfo("Didn't receive STATUS from server!");
        bGoodUnit = false;
    }

    // Don't care if we saw a message or not

    if (!bGoodUnit)
    {
        WriteInfo("Error decoding the work unit!");
        return false;
    }    

    return true;
#endif
}

bool PutNextWorkLoad()
{
#ifdef FAKE_GET_PUT
    WriteInfo("Put called!");
    return true;
#else
    if (g_bNoMore)
    {
        return false;
    }

    if (!g_pWorkUnit->szWuid || strlen(g_pWorkUnit->szWuid) == 0 ||
        !g_pWorkUnit->szNonce || strlen(g_pWorkUnit->szNonce) == 0)
    {
        return false;
    }

    if (g_pSettings->nDownloadAtOnce > 1)
    {
        char szInfo[64];
        sprintf(szInfo, "Sending the results (%d/%d)",
            g_nCurWorkUnit + 1, g_pSettings->nDownloadAtOnce);
        WriteInfo(szInfo);
    }
    else
    {
        WriteInfo("Sending the results");
    }

    char szURL[MAX_STRING];
    char szTemp[MAX_STRING];

    strcpy(szURL, g_pWorkUnit->szResultURL);

    SafeAdd(szURL, "?STATUS=", "OKAY");
    if (strlen(g_pWorkUnit->szDecodedMatch) > 0)
    {
        WriteInfo("Hey!  You found the solution!");
        WriteInfo(g_pWorkUnit->szDecodedMatch);

        SafeAdd(szURL, "&SOLUTION=", g_pWorkUnit->szDecodedMatch);
    }
    SafeAdd(szURL, "&USERID=", g_pSettings->szUser); 
    SafeAdd(szURL, "&WUID=", g_pWorkUnit->szWuid); 
    SafeAdd(szURL, "&NONCE=", g_pWorkUnit->szNonce); 
    SafeAdd(szURL, "&CVER=", CLIENT_NAME "_" VERSION_TEXT);

    // Fixup the byte order
    DWORD dwProof = g_pWorkUnit->dwProof;
    unsigned short x, y;
    x = (unsigned short)(dwProof >> 16);
    y = (unsigned short)(dwProof & 0x0000ffffL);
    x = (unsigned short)((x << 8) | (x >> 8));
    y = (unsigned short)((y << 8) | (y >> 8));
    dwProof = (unsigned long) x;
    dwProof |= ((unsigned long) y) << 16;

    if (strlen(g_pWorkUnit->szDecodedMatch) > 0)
    {
        // The proof is the match
        sprintf(szTemp, "%08X", 0);
    }
    else
    {
        sprintf(szTemp, "%08X", dwProof);
    }
    SafeAdd(szURL, "&PROOF=", szTemp);
    
    // Use the Windows Internet APIs to make our lives much easier
    HANDLE hInternet;
    HANDLE hFile;
    BYTE lpData[1024] = {0};
    BYTE * lpDataTemp = lpData;
    DWORD dwCount = 1024;
    DWORD dwReadTotal = 0;
    DWORD dwRead;

    hInternet = InternetOpen("TiVoCrack", 
        INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, NULL);
    if (hInternet == NULL)
    {
        WriteInfo("Unable to open internet connection!");
        return false;
    }
    hFile = InternetOpenUrl(
        hInternet, 
        szURL,
        NULL, NULL, 
        INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_NO_UI | 
        INTERNET_FLAG_PRAGMA_NOCACHE | INTERNET_FLAG_RELOAD |
        INTERNET_FLAG_KEEP_CONNECTION,
        NULL);
    if (hFile == NULL)
    {
        WriteInfo("Unable to open URL!");
        return false;
    }

    do 
    {
        if (InternetReadFile(hFile, lpDataTemp, dwCount, &dwRead) == 
            FALSE)
        {
            WriteInfo("Unable to read data from URL!");
            return false;
        }
        else
        {
            dwReadTotal += dwRead;
            lpDataTemp += dwRead;
            dwCount -= dwRead;
        }
    } while (dwRead);

    InternetCloseHandle(hFile);
    InternetCloseHandle(hInternet);

    WriteInfo("Done");

    g_pWorkUnit->szDecodedMatch[0] = 0;

    return true;
#endif
}

//Set the starting point
inline void SetStart()
{

    g_bWorkerRunning = true;
    g_bNoMoreWords = false;

    int i;
    int j;

    memset(g_szCurrentWord, 0, MAX_LETTERS);
    memset(g_nCurrentWord, 0, MAX_LETTERS);
    g_cCurrentWord = 0;

    for (i = 0; i < (signed) strlen(g_pSettings->szPattern); i ++)
    {
        if (g_pSettings->szPattern[i] == '?')
        {
            g_nCurrentWord[i] = 0;
            g_szCurrentWord[i] = g_pSettings->szAlphabet[0];
        }
        else if (g_pSettings->szPattern[i] != ' ')
        {
            g_szCurrentWord[i] = g_pSettings->szPattern[i];
            for (j = 0; j < g_pSettings->cAlphabet; j ++)
            {
                if (g_pSettings->szAlphabet[j] == g_pSettings->szPattern[i])
                {
                    g_szCurrentWord[i] = g_pSettings->szAlphabet[j];
                    g_nCurrentWord[i] = (BYTE) j;
                }
            }
        }
        else
        {
            g_szCurrentWord[i] = g_pSettings->szPattern[i];
            g_nCurrentWord[i] = 0;
        }
        g_cCurrentWord ++;
    }

    // Also deal with the hash
#define HEXVALUE(c) ((BYTE)(c>='A'?(c>='a'?c-'a'+10:c-'A'+10):c-'0'))
    for (i=0;i<20;i++)
    {
        ((BYTE*)g_dwKey1)[i]=
            (BYTE)((HEXVALUE(g_pSettings->szHash[2*i])<<4)+
            HEXVALUE(g_pSettings->szHash[2*i+1]));
    }
    for (i=0;i<20;i++)
    {
        ((BYTE*)g_dwKey2)[i]=((BYTE*)g_dwKey1)[3-(i%4)+((i>>2)<<2)];
    }

}

// Handle the options on the command line.
bool ProcessCommandLine()
{

    // Split up the command line, paying attention to 
    // quotes and backslashes

    char * szTemp;
    if (g_bIsService)
    {
        static char szSettings[MAX_PATH];
        GetModuleFileName(NULL, szSettings, MAX_PATH);
        int i = strlen(szSettings);
        while (i > 0 && szSettings[i] != '\\')
        {
            szSettings[i] = 0;
            i--;
        }
        if (i == 0)
        {
            strcpy(szSettings, "settings.txt");
        }
        else
        {
            strcat(szSettings, "settings.txt");
        }
        FILE * f = fopen(szSettings, "r");
        g_szServiceCmd[0] = 'x';
        g_szServiceCmd[1] = ' ';
        g_szServiceCmd[2] = 0;
        fgets(g_szServiceCmd+2, 1024, f);
        char * sz = g_szServiceCmd;
        while (*sz)
        {
            if (*sz == '\n' || *sz == '\r')
            {
                *sz = 0;
            }
            sz++;
        }
        fclose(f);
        szTemp = g_szServiceCmd;
    }
    else
    {
        szTemp = GetCommandLine();
    }
    char * szCmd;
    int i;
    char ** szArgs;
    char * szTo;
    int nArgs = 0;
    bool bInQuote = false;
    bool bNextLiteral = false;

    szCmd = (char *) xmalloc(strlen(szTemp)+1);
    szTo = szCmd;
    if (!szCmd)
    {
        return false;
    }

    while (*szTemp)
    {
        if (bNextLiteral)
        {
            if (*szTemp == ' ')
            {
                *szTo = 1;
            }
            else
            {
                *szTo = *szTemp;
            }
            *szTo++;
            bNextLiteral = false;
        }
        else
        {
            if (*szTemp == '"')
            {
                bInQuote = !bInQuote;
            }
            else if (*szTemp == ' ')
            {
                if (bInQuote)
                {
                    *szTo = 1;
                }
                else
                {
                    *szTo = ' ';
                    nArgs ++;
                }
                szTo ++;
            }
            else if ((*szTemp == '\\') && (nArgs > 0))
            {
                bNextLiteral = true;
            }
            else
            {
                *szTo = *szTemp;
                szTo++;
            }
        }
        szTemp ++;
    }
    *szTo = 0;
    nArgs ++;

    szArgs = (char**) xmalloc(sizeof(char *) * nArgs);
    if (!szArgs)
    {
        return false;
    }

    // It's parsed, now put the results in szArgs
    nArgs = 0;
    szTemp = szCmd;
    szTo = szCmd;
    do
    {
        if (*szTemp == ' ' || *szTemp == 0)
        {
            szArgs[nArgs] = (char *) xmalloc(szTemp - szTo + 1);
            memset(szArgs[nArgs], 0, szTemp - szTo + 1);
            memcpy(szArgs[nArgs], szTo, szTemp-szTo);
            szTo = szTemp + 1;
            nArgs ++;
        } 
        else if (*szTemp == 1)
        {
            *szTemp = ' ';
        }
        szTemp ++;
    } while (*(szTemp-1));

    // Run through the tokens (ignoring the first, that's the 
    // program itself)
    bool bShowHelp = false;
    for (i = 1; i < nArgs; i ++)
    {
        if (strlen(szArgs[i]) >= 1)
        {
            char cSwitch;
            char * szOption;
            switch (szArgs[i][0])
            {
            case '/':
            case '-':
                if (strlen(szArgs[i]) >= 2)
                {
                    cSwitch = szArgs[i][1];
                    szOption = szArgs[i]+2;
                }
                else
                {
                    cSwitch = szArgs[i][0];
                    szOption = szArgs[i]+1;
                }
                break;
            default:
                cSwitch = szArgs[i][0];
                szOption = szArgs[i]+1;
            }

            switch(cSwitch)
            {
            case 'l':
            case 'L':
                g_pSettings->bLocalMode = true;
                break;

            case 'p':
            case 'P':
                xfree(g_pSettings->szPattern);
                g_pSettings->szPattern = xstrdup(szOption);
                break;

            case 'c':
            case 'C':
                xfree(g_pSettings->szHash);
                g_pSettings->szHash = xstrdup(szOption);
                break;

            case 'u':
            case 'U':
                xfree(g_pSettings->szUser);
                g_pSettings->szUser = xstrdup(szOption);
                break;

            case 'a':
            case 'A':
                xfree(g_pSettings->szAlphabet);
                g_pSettings->szAlphabet = xstrdup(szOption);
                g_pSettings->cAlphabet = strlen(g_pSettings->szAlphabet);
                break;

            case 'k':
            case 'K':
                xfree(g_pSettings->szGetURL);
                g_pSettings->szGetURL = xstrdup(szOption);
                break;

            case 't':
            case 'T':
                g_pSettings->dwThreads = strtol(szOption, NULL, 10);
                if (g_pSettings->dwThreads < 1 || g_pSettings->dwThreads > 10)
                {
                    g_pSettings->dwThreads = 1;
                }
                break;

            case 's':
            case 'S':
                g_pSettings->nSleepMins = strtol(szOption, NULL, 10);
                if (g_pSettings->nSleepMins < 1 || g_pSettings->nSleepMins > 60)
                {
                    g_pSettings->nSleepMins = 1;
                }
                break;

            case 'o':
            case 'O':
                g_pSettings->nOutMode = strtol(szOption, NULL, 10);
                if (g_pSettings->nOutMode < 1 || g_pSettings->nOutMode > 4)
                {
                    g_pSettings->nOutMode = 1;
                }
                break;

            case 'q':
            case 'Q':
                g_pSettings->bSilent = true;
                break;

            case 'R':
            case 'r':
                g_pSettings->bLowPri = true;
                break;

            case 'V':
            case 'v':
                if (strcmp(szOption, "forever") == 0 ||
                    strcmp(szOption, "infinite") == 0)
                {
                    g_pSettings->nRetries = -1;
                }
                else
                {
                    g_pSettings->nRetries = strtol(szOption, NULL, 10);
                    if (g_pSettings->nRetries < 0 || g_pSettings->nRetries > 10000)
                    {
                        g_pSettings->nRetries = -1;
                    }
                }
                break;

            case 'z':
            case 'Z':
                g_pSettings->nStart = strtol(szOption, NULL, 10);
                if (g_pSettings->nStart < 1 || g_pSettings->nStart > 2)
                {
                    g_pSettings->nStart = 0;
                }
                break;

            case 'e':
            case 'E':
                g_pSettings->nService = strtol(szOption, NULL, 10);
                if (g_pSettings->nService < 1 || g_pSettings->nService > 2)
                {
                    g_pSettings->nService = 0;
                }
                break;

            case 'i':
            case 'I':
                g_pSettings->bReportKKeys = true;
                break;

            case 'm':
            case 'M':
                g_nCurWorkUnit = g_pSettings->nDownloadAtOnce;
                g_pSettings->nDownloadAtOnce = strtol(szOption, NULL, 10);
                if (g_pSettings->nDownloadAtOnce < 1 || g_pSettings->nDownloadAtOnce > 30)
                {
                    g_pSettings->nDownloadAtOnce = 30;
                }
                int i;
                for (i = 0; i < g_nCurWorkUnit; i ++)
                {
                    xuntrack(g_pWorkUnits[i]);
                }
                xfree(g_pWorkUnits);
                g_pWorkUnits = (CWorkUnit**) xmalloc((sizeof(CWorkUnit*)) * g_pSettings->nDownloadAtOnce);
                for (i = 0; i < g_pSettings->nDownloadAtOnce; i ++)
                {
                    g_pWorkUnits[i] = new CWorkUnit();
                    xtrack(g_pWorkUnits[i]);
                }
                g_pWorkUnit = g_pWorkUnits[0];
                g_nCurWorkUnit = 0;
                break;

            default:
            case 'h':
            case 'H':
                bShowHelp = true;
                break;
            }
        }
    }

    // Free up any used memory
    for (i = 0; i < nArgs; i ++)
    {
        xfree(szArgs[i]);
    }
    xfree(szArgs);
    xfree(szCmd);

    if (bShowHelp)
    {
        HRSRC hRsrc = FindResource(
            g_hInstance, MAKEINTRESOURCE(IDR_OPTIONS), "DataFiles");
	    LPVOID lpMem = (LPVOID) LoadResource(NULL, hRsrc);
	    lpMem = (LPVOID) LockResource(lpMem);
        MessageBox(0, (char *) lpMem, 
            "TiVo Crack v" VERSION_TEXT " options", MB_TOPMOST);
        return false;
    }

    if (g_pSettings->bLocalMode)
    {
        DumpSettings();
    }
    SetStart();

    return true;

}

// Dump the current settings
inline void DumpSettings()
{
    if (!g_pSettings->bSilent)
    {
        char szOut[MAX_STRING];
        sprintf(szOut, "User = [%s], Work Unit = %s", 
            g_pSettings->szUser, 
            g_pWorkUnit->szWuid?g_pWorkUnit->szWuid:"(none)");
        WriteInfo(szOut);
        sprintf(szOut, "Alphabet = [%s]", g_pSettings->szAlphabet);
        WriteInfo(szOut);
        sprintf(szOut, "Key = [%s]", g_pSettings->szHash);
        WriteInfo(szOut);
        sprintf(szOut, "Pattern = [%s]", g_pSettings->szPattern);
        WriteInfo(szOut);
        sprintf(szOut, "Threads = %d, Local = %s, Silent = %s", 
            g_pSettings->dwThreads, 
            g_pSettings->bLocalMode?"true":"false",
            g_pSettings->bSilent?"true":"false");
        WriteInfo(szOut);
        sprintf(szOut, 
            g_pSettings->nRetries == -1?
            "Priority = %s, Sleep = %dmin, Retries = %s": 
            "Priority = %s, Sleep = %dmin, Retries = %d", 
            g_pSettings->bLowPri?"lower":"normal", 
            g_pSettings->nSleepMins, 
            (g_pSettings->nRetries == -1?(LPVOID)"infinite":(LPVOID)g_pSettings->nRetries));
        WriteInfo(szOut);
        sprintf(szOut, "Logging = %s",
            (g_pSettings->nOutMode == 1?"both":
              (g_pSettings->nOutMode == 2?"log.txt":
                (g_pSettings->nOutMode == 3?"console":"none"))));
        WriteInfo(szOut);
    }
}

// The main worker thread
DWORD WINAPI FindTiVoKey(LPVOID)
{
    AddThread();
#ifdef TIME_CALCULATION
    DWORD   dwFindWordStart = 0;
    DWORD   dwFindWordEnd = 0;
    DWORD   dwBruteStart = 0;
    DWORD   dwBruteEnd = 0;
    bool    bOneRun = false;
#endif

    SHA1_CONTEXT sha1;

    // Our private queue of strings to try
    DWORD dwProof = 0;
    char * szAlphabet;
    int cAlphabet;
    char * szPattern;
    int cPattern;
    int nCurrentWord[MAX_LETTERS+1];
    char szCurrentWord[MAX_LETTERS+1];
    int cCurrentWord;
    int i;

    EnterCriticalSection(&g_crit);

    szAlphabet = xstrdup(g_pSettings->szAlphabet);
    cAlphabet = g_pSettings->cAlphabet;
    szPattern = xstrdup(g_pSettings->szPattern);
    cPattern = strlen(szPattern);

    LeaveCriticalSection(&g_crit);

    int cToTry;

    while (true)
    {
        // Grab the next PER_THREAD strings and store them
        EnterCriticalSection(&g_crit);

        // First off, store the proof
        g_pWorkUnit->dwProof ^= dwProof;
        dwProof = 0;
#ifdef TIME_CALCULATION
        if (bOneRun)
        {
            g_dwFindWordStart[g_nCurTime] = dwFindWordStart;
            g_dwFindWordEnd[g_nCurTime] = dwFindWordEnd;
            g_dwBruteStart[g_nCurTime] = dwBruteStart;
            g_dwBruteEnd[g_nCurTime] = dwBruteEnd;
            g_nCurTime++;
            if (g_nCurTime >= TIME_COUNT)
            {
                g_nCurTime = 0;
            }
            g_dwBrute += dwBruteEnd - dwBruteStart;
            g_dwFind += dwFindWordEnd - dwFindWordStart;
        }
        dwFindWordStart = GetTickCount();
#endif

        if (g_bNoMoreWords)
        {
            g_bWorkerRunning = false;
        }
        if (!g_bWorkerRunning)
        {
            xfree(szAlphabet);
            xfree(szPattern);
            SetEvent(g_eventStop);
            g_nWorkerRunning --;
            LeaveCriticalSection(&g_crit);
            RemoveThread();
            return 0;
        }
        cToTry = 0;

        for (i = 0; i <= g_cCurrentWord; i ++)
        {
            szCurrentWord[i] = g_szCurrentWord[i];
            nCurrentWord[i] = g_nCurrentWord[i];
        }
        cCurrentWord = g_cCurrentWord;

        // Keep the first one from this batch around for the 
        // user message
        sprintf(g_szMessage, "[%s]", g_szCurrentWord);

        bool bFound = false;
        for (i = 0; i < PER_THREAD && !g_bNoMoreWords; i ++)
        {
            cToTry ++;
            bFound = FindNextWord(szAlphabet, cAlphabet, szPattern, cPattern, g_nCurrentWord, g_szCurrentWord);
            if (!bFound)
            {
                g_bNoMoreWords = true;
            }
        }
        g_nKeysCalced += cToTry;
#ifdef TIME_CALCULATION
        dwFindWordEnd = GetTickCount();
#endif
        LeaveCriticalSection(&g_crit);

        // Now run through and try what we've stored
#ifdef TIME_CALCULATION
        dwBruteStart = GetTickCount();
#endif
        //Need to work backwards since sha1 can scribble after the string
        for (i = 0; i < cToTry; i ++)
        {
            if (IsTiVoKey(&dwProof, &sha1, szCurrentWord, cCurrentWord))
            {
                // We have a hit, store the hit, and if we're in local mode,
                // shutdown the worker threads, otherwise continue calculating
                // the remaining keyspace so we can prove to the server
                // we worked.

                EnterCriticalSection(&g_crit);
                g_pWorkUnit->dwProof ^= dwProof;
                dwProof = 0;

                sprintf(g_szMessage, 
                    "Found!: %d [%s]", cCurrentWord, szCurrentWord);
                strcpy(g_pWorkUnit->szDecodedMatch, szCurrentWord);

                xfree(szAlphabet);
                xfree(szPattern);
                g_nWorkerRunning --;
                g_bWorkerRunning = false;
                SetEvent(g_eventStop);
                LeaveCriticalSection(&g_crit);
                RemoveThread();
                return 0;

            }
            FindNextWord(szAlphabet, cAlphabet, szPattern, cPattern, 
                nCurrentWord, szCurrentWord);
        }
#ifdef TIME_CALCULATION
        dwBruteEnd = GetTickCount();
        bOneRun = true;
#endif
    }
}

// The worlds stupidest helper function, just adds a timestamp
//  and writes szOut to the console and log.txt
void WriteInfo(char * szOut)
{
    static char szLog[MAX_PATH];
    static bool bFoundLog = false;
    if (!bFoundLog)
    {
        GetModuleFileName(NULL, szLog, MAX_PATH);
        int i = strlen(szLog);
        while (i > 0 && szLog[i] != '\\')
        {
            szLog[i] = 0;
            i--;
        }
        if (i == 0)
        {
            strcpy(szLog, "log.txt");
        }
        else
        {
            strcat(szLog, "log.txt");
        }
        bFoundLog = true;
    }

    static WORD wMonth = 0;
    static WORD wDay = 0;
    static WORD wYear = 0;

    char szOut2[MAX_STRING + 50];
    SYSTEMTIME st;
    GetLocalTime(&st);

    if (wMonth != st.wMonth || wDay != st.wDay || wYear != st.wYear)
    {
        wMonth = st.wMonth;
        wDay = st.wDay;
        wYear = st.wYear;
        sprintf(szOut2, " %d/%d/%d ",
            st.wMonth, st.wDay, st.wYear);
        WriteInfo(szOut2);
    }
    sprintf(szOut2, "%d:%02d:%02d: ",
        st.wHour, st.wMinute, st.wSecond);
    strcat(szOut2, szOut);
    
    if (g_pSettings->nOutMode == 1 || g_pSettings->nOutMode == 2)
    {
        FILE * fout = fopen(szLog, "a+");
        fwrite(szOut2, sizeof(char), strlen(szOut2), fout);
        fwrite("\n", 1, 1, fout);
        fclose(fout);
    }

    if (g_pSettings->nOutMode == 1 || g_pSettings->nOutMode == 3)
    {
        char * szTemp = xstrdup(szOut2);
        PostMessage(g_pMainWnd->GethWnd(), WM_USER_LOG, 0, (LPARAM) szTemp);
    }

}


// Macro to try and match the hash against what we know.  
// Test both endians (this is slightly faster than calling 
// into memcmp)
#define KEY \
( ( g_dwKey1[0] == ((DWORD*) psha1->buf32)[0] && \
    g_dwKey1[1] == ((DWORD*) psha1->buf32)[1] && \
    g_dwKey1[2] == ((DWORD*) psha1->buf32)[2] && \
    g_dwKey1[3] == ((DWORD*) psha1->buf32)[3] && \
    g_dwKey1[4] == ((DWORD*) psha1->buf32)[4] ) || \
  ( g_dwKey2[0] == ((DWORD*) psha1->buf32)[0] && \
    g_dwKey2[1] == ((DWORD*) psha1->buf32)[1] && \
    g_dwKey2[2] == ((DWORD*) psha1->buf32)[2] && \
    g_dwKey2[3] == ((DWORD*) psha1->buf32)[3] && \
    g_dwKey2[4] == ((DWORD*) psha1->buf32)[4] ) )

// Hashes the incoming string and compares it to the stored hashes
inline int IsTiVoKey(DWORD * pdwProof, SHA1_CONTEXT * psha1, 
                     char * szString, int nLen)
{
    sha1_init(psha1);
    sha1_write(psha1, (byte*) szString, nLen);
    sha1_final(psha1);

    (*pdwProof) ^= (((DWORD*) psha1->buf32))[0];

    return KEY;
}

inline bool FindNextWord(
char * szAlphabet,
int cAlphabet,
char * szPattern, 
int cPattern,
int * nCurrentWord,
char * szCurrentWord
)
{
    int nPos = 0;
    while (szPattern[nPos] != '?' && 
        nPos < (signed) cPattern)
    {
        nPos ++;
    } 

    while (true)
    {
        if (nCurrentWord[nPos] == cAlphabet-1)
        {
            nCurrentWord[nPos] = 0;
            szCurrentWord[nPos] = szAlphabet[0];

            do 
            {
                nPos ++;
            } while (szPattern[nPos] != '?' && 
                nPos < (signed) cPattern);

            if (nPos == (signed) cPattern)
            {
                return false;
            }
        }
        else
        {
            nCurrentWord[nPos] ++;
            szCurrentWord[nPos] = szAlphabet[nCurrentWord[nPos]];
            return true;
        }
    }

}

DWORD WINAPI WatcherThread(LPVOID)
{
    AddThread();
#ifdef TIME_CALCULATION
    g_nCurTime = 0;
#endif

    int i;

    WriteInfo("-- TiVoCrack " VERSION_TEXT " started --");

    __try { // you never know
        while (true)
        {
            xtrack_dump();
            if (!g_pSettings->bLocalMode)
            {
                if (g_bNoMore)
                {
                    PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
                    if (g_bShutdownWindow)
                    {
                        PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
                    }
                    RemoveThread();
                    return 0;
                }

                if (g_nCurWorkUnit == 0)
                {
                    int i;
                    for (i = 0; i < g_pSettings->nDownloadAtOnce; i ++)
                    {
                        g_pWorkUnit = g_pWorkUnits[i];
                        g_nCurWorkUnit = i;
                        if (!SafeNextWorkLoad(GetNextWorkLoad))
                        {
                            WriteInfo("Next workload failed, giving up");
                            PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
                            if (g_bShutdownWindow)
                            {
                                PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
                            }
                            RemoveThread();
                            return 0;
                        }
                    }
                    g_nCurWorkUnit = 1;
                    g_pWorkUnit = g_pWorkUnits[0];
                }
                else
                {
                    g_pWorkUnit = g_pWorkUnits[g_nCurWorkUnit];
                    g_nCurWorkUnit ++;
                }
                if (g_pSettings->nDownloadAtOnce > 1)
                {
                    char szInfo[64];
                    sprintf(szInfo, "Working on unit %d of %d",
                        g_nCurWorkUnit, g_pSettings->nDownloadAtOnce);
                    WriteInfo(szInfo);
                }
                g_pSettings->SetFromWorkUnit(g_pWorkUnit);
                DumpSettings();
                SetStart();
            }

            //Start the threads
            EnterCriticalSection(&g_crit);
            for (i = 0; i < (signed) g_pSettings->dwThreads; i ++)
            {
                DWORD dwThread;
                HANDLE hThread = CreateThread(NULL, 0, FindTiVoKey, 
                    0, NULL, &dwThread);
                if (hThread == NULL)
                {
                    WriteInfo("Unable to create worker thread!!");
                    PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
                    if (g_bShutdownWindow)
                    {
                        PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
                    }
                    RemoveThread();
                    return 0;
                }
                else
                {
                    g_nWorkerRunning ++;
                    if (g_pSettings->bLowPri)
                    {
                        SetThreadPriority(hThread, 
                            THREAD_PRIORITY_BELOW_NORMAL);
                    }
                }
            }
            g_dwTickStart = GetTickCount();
            g_nKeysCalced = 0;
            LeaveCriticalSection(&g_crit);

            // Just wait a while for things to get interesting
            WaitForSingleObject(g_eventStop, 5000);

            bool bRun = true;
            while (bRun)
            {
                // Display the latest message and loop
                EnterCriticalSection(&g_crit);
#ifdef TIME_CALCULATION
                DWORD dwTotalFind = 0;
                DWORD dwTotalBrute = 0;
                int cEntries = 0;
                int i;
                for (i = 0; i < TIME_COUNT; i ++)
                {
                    if (g_dwFindWordStart[i])
                    {
                        cEntries++;
                        dwTotalFind += 
                            g_dwFindWordEnd[i] - g_dwFindWordStart[i];
                        dwTotalBrute += 
                            g_dwBruteEnd[i] - g_dwBruteStart[i];
                    }
                }
                if (cEntries)
                {
                    char szMsg[1000];
                    dwTotalFind /= cEntries;
                    dwTotalBrute /= cEntries;
                    sprintf(szMsg, 
                        "Avg per find: %d -- Avg per brute: %d",
                        dwTotalFind, dwTotalBrute);
                    WriteInfo(szMsg);
                }
#endif
                WriteInfo(g_szMessage);
                if (!g_bWorkerRunning && g_nWorkerRunning == 0)
                {
                    bRun = false;
                }
                LeaveCriticalSection(&g_crit);
                if (bRun)
                {
                    WaitForSingleObject(g_eventStop, 
                        60000 * g_pSettings->nSleepMins);
                }
            } // bRun

            EnterCriticalSection(&g_crit);
            g_dwTickEnd = GetTickCount();
            if (g_pSettings->bReportKKeys)
            {
                char szTime[100];
                double fTime = ((double)(g_dwTickEnd - g_dwTickStart))/((double)1000);
                double fPerSec = g_nKeysCalced / fTime / ((double)1000);

                sprintf(szTime, "Elapsed time: %.2f seconds", fTime);
                WriteInfo(szTime);
                sprintf(szTime, "%.1f kKeys/s",fPerSec);
                WriteInfo(szTime);
            }
            LeaveCriticalSection(&g_crit);

            if (!g_pSettings->bLocalMode)
            {
                if (g_bNoMore)
                {
                    PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
                    if (g_bShutdownWindow)
                    {
                        PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
                    }
                    RemoveThread();
                    return 0;
                }
                if (g_nCurWorkUnit >= g_pSettings->nDownloadAtOnce)
                {
                    int i;
                    for (i = 0; i < g_pSettings->nDownloadAtOnce; i ++)
                    {
                        g_pWorkUnit = g_pWorkUnits[i];
                        g_nCurWorkUnit = i;
                        SafeNextWorkLoad(PutNextWorkLoad);
                    }
                    g_pWorkUnit = g_pWorkUnits[0];
                    g_nCurWorkUnit = 0;
                }
                if (g_bFinishCurrent)
                {
                    PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
                    if (g_bShutdownWindow)
                    {
                        PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
                    }
                    RemoveThread();
                    return 0;
                }
            }
            else
            {
                WriteInfo("All done");
#ifdef TIME_CALCULATION
                char szMsg[1000];
                sprintf(szMsg, 
                    "Total find: %d -- Total brute: %d",
                    g_dwFind, g_dwBrute);
                WriteInfo(szMsg);
#endif
                PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
                if (g_bShutdownWindow)
                {
                    PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
                }
                RemoveThread();
                return 0;
            }
        }
    } 
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        // Just abort the world
        CtrlHandler(0);
    }
    PostMessage(g_pMainWnd->GethWnd(), WM_USER_ERROR, 0, 0);
    if (g_bShutdownWindow)
    {
        PostMessage(g_pMainWnd->GethWnd(), WM_REALLY_CLOSE, 0, 0);
    }

    RemoveThread();
    return 0;
}

void AddThread()
{
    EnterCriticalSection(&g_crit);

    CThread * pCur = new CThread();
    xtrack(pCur);

    pCur->hThread = GetCurrentThread();
    pCur->dwID = GetCurrentThreadId();
    DuplicateHandle(GetCurrentProcess(), pCur->hThread, GetCurrentProcess(), 
        &pCur->hThread, DUPLICATE_SAME_ACCESS, TRUE, DUPLICATE_SAME_ACCESS);
    xtrack(pCur->hThread);

    pCur->pNext = g_pThread;
    g_pThread = pCur;

    LeaveCriticalSection(&g_crit);
}

void RemoveThread()
{
    EnterCriticalSection(&g_crit);

    DWORD dwID = GetCurrentThreadId();
    CThread * pCur;
    CThread * pLast = NULL;
    for (pCur = g_pThread; pCur; pCur = pCur->pNext)
    {
        if (pCur->dwID == dwID)
        {
            if (pLast)
            {
                pLast->pNext = pCur->pNext;
            }
            else
            {
                g_pThread = pCur->pNext;
            }
            xuntrack(pCur->hThread);
            CloseHandle(pCur->hThread);
            xuntrack(pCur);
            delete pCur;
            pCur = NULL;
            break;
        }
        pLast = pCur;
    }

    LeaveCriticalSection(&g_crit);
}