#ifndef _CRACKER_H
#define _CRACKER_H

class Cracker
{
 public:
  Cracker();
  ~Cracker();

  void setCtext(char *ctext);
  void setAlphabet(char *alphabet);
  char *getSolution();

  bool searchpattern(char *pattern, char *seed);

  /* how many plain texts have we tried? */
  long getCount();
  unsigned int getProof();

  void enableProgress(bool enable);
  void setProgressFrequency(int chars);

 private:
  inline bool fastMemCmp20(char *p1, char *p2);

  bool searchpattern_nonrec(char *pattern);

  bool searchpattern_recursive(char *pattern, char *state, int patternpos);
  inline bool testPtext(char *ptext, int patternlen);
  inline bool testCtext(char *ctext);
  
  void setSolution(char *sol);

  void printKey(char *k);
  int hexValue(int c);

  char *_alphabet;
  char *_pattern;
  char *_solution;

  int _patternLen;
  int _alphabetLen;

  /* we print out status messages every time we update the
     state at an offset < _statusLen. */
  int _statusLen;

  /* Update the status every time we search this many characters */
  int _statusEvery;

  /* parsed versions of our cipher text. */
  char *_ctext0123,*_ctext3210,*_ctext2301,*_ctext1032;

  /* how many plain texts have we tried? */
  long _testCount;
  unsigned int _proof;

  bool _showProgress;

  char *_md;
};

#endif
