#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <string.h>
#include "Logger.h"

int Logger::CRITICAL=1;
int Logger::HIGH=2;
int Logger::MED=3;
int Logger::LOW=4;
int Logger::DEBUG=5;

Logger::Logger()
{
  _logFile=NULL;
  _logConsole=stdout;
  _loggingLevel=3;
}

Logger::~Logger()
{
}

void Logger::setFile(FILE *f)
{
  _logFile=f;
}

void Logger::setConsole(FILE *f)
{
  _logConsole=f;
}

void Logger::setLogLevel(int level)
{
  _loggingLevel=level;
}

void Logger::logf(int loglevel, char *format, ...)
{
  va_list ap;

  if (loglevel>_loggingLevel)
    return;

  if (_logFile!=NULL)
    {
      time_t thetime=time(NULL);

      va_start(ap,format);
      char *timestr=ctime(&thetime);
      // get rid of that pesky \n at the end of timestr
      timestr[strlen(timestr)-1]=0;
      fprintf(_logFile,"%s\t",timestr);
      vfprintf(_logFile, format, ap);
      fprintf(_logFile,"\n");
      va_end(ap);
    }

  if (_logConsole!=NULL)
    {
      va_start(ap,format);
      vfprintf(_logConsole, format, ap);
      fprintf(_logConsole,"\n");
      va_end(ap);
    }
}

