#ifndef _MAINAPP_H
#define _MAINAPP_H

#include "GetOpt.h"
#include "Cracker.h"
#include "Vector.h"
#include "Logger.h"

class MainApp
{
 public:
  MainApp();
  ~MainApp();

  int run(int argc, char *argv[]);

 private:
  void doBenchmark();
  bool doSelfTest();
  bool burnIn();
  void doLocal();
  void doHelp();
  void doRemote();
  void doRemoteThread();
  bool doOneWorkUnit(char *server, char *user);

  void configureCracker(Cracker *cracker);
  bool doPattern(Cracker *cracker, char *pattern, char *seed);

  void logf(int loglevel, char *format, ...);

  void trim(char *b);

  GetOpt _getopt;
  char *_appname;
  
  Logger _log;
};

#endif
