// Google + someone's CVS archive == Borrowed SHA1 code.

#ifdef __cplusplus
extern "C"
{
#endif

typedef unsigned int u32;
typedef unsigned char byte;

typedef struct {
    u32  h0,h1,h2,h3,h4;
    u32  nblocks;
    union {
        byte buf[64];
        u32  buf32[5];
    };
    int  count;
} SHA1_CONTEXT;


void    sha1_init(SHA1_CONTEXT *hd);
void    sha1_write(SHA1_CONTEXT *hd, byte *inbuf, size_t inlen);
void    sha1_final(SHA1_CONTEXT *hd);
byte *  sha1_read(SHA1_CONTEXT *hd);

#ifdef __cplusplus
}
#endif
